C     RDPG MODEL
C     DFUNC.FOR
C     GET GRADIENT G(I)


      SUBROUTINE DFUNC(P,G)

      REAL P(1:4), G(1:4)
      REAL X(1:4), X_DX(1:4)
      REAL TARGET
      REAL F_X
      REAL F_X_FORWARD(4), F_X_BACKWARD(4)
                  
C     FUNCTION VALUE AT X
      DO I = 1, 4
       X(I) = P(I)
      END DO
      CALL MDLCLC(X, TARGET)
      F_X = TARGET

C     FUNCTION VALLUE AT X+DELTA_X
      DO I = 1, 4
       DELTA_X = P(I)/100.0
       IF (DELTA_X .EQ. 0.00) THEN
        DELTA_X = 0.001
       END IF 
       DO J = 1, 4
        IF (J .EQ. I) THEN
         X_DX(J) = P(J) + DELTA_X
        ELSE
         X_DX(J) = P(J)
        END IF
       END DO
       CALL MDLCLC(X_DX, TARGET)
       F_X_FORWARD(I) = TARGET

C     FUNCTION VALLUE AT X+DELTA_X       
       DO J = 1, 4
        IF (J .EQ. I) THEN
         X_DX(J) = P(J) - DELTA_X
        ELSE
         X_DX(J) = P(J)
        END IF
       END DO
       CALL MDLCLC(X_DX, TARGET)
       F_X_BACKWARD(I) = TARGET

C     PREVENT UNUSUAL CASE      
       IF (DELTA_X .EQ. 0.00) THEN
        WRITE (*,*) 'DELTA_X IS 0.00. PRESS ANY KEY TO STOP.'
        PAUSE
        STOP
       END IF                

C     GRADIENT ARRAY G(I) BY CENTRAL DIFFERENCE METHOD
       G(I) = (F_X_FORWARD(I) - F_X_BACKWARD(I)) / (2*DELTA_X)

      END DO
       
      END 