C     RDPG MODEL
C     LINMIN.FOR: FROM PRESS, ET AL., 1986, P 300-301.
C     IMPLEMENT LINE MINIMIZATION


      SUBROUTINE LINMIN(P,XI,N,FRET)
      PARAMETER (NMAX=50,TOL=1.E-4)
      EXTERNAL F1DIM
      DIMENSION P(N),XI(N)
      COMMON /F1COM/ NCOM,PCOM(NMAX),XICOM(NMAX)

C     ADDED CODE BELOW TO CONTROL RANGE OF VARIABLES
      IF ( P(2) .LE. 0.01) THEN
       P(2) = 0.01
      END IF
      IF ( P(2) .GE. 1.0) THEN
       P(2) = 1.0
      END IF
       
      IF ( P(1) .LE. 15.0) THEN
       P(1) = 15.0
      END IF
      IF ( P(1) .GE. 1440.0) THEN
       P(1) = 1440.0
      END IF
       
      IF ( P(3) .LE. 15.0) THEN
       P(3) = 15.0
      END IF
      IF ( P(3) .GE. 1440.0) THEN
       P(3) = 1440.0
      END IF
       
      IF ( P(4) .LE. 0.001) THEN
       P(4) = 0.001
      END IF
C     ADDED CODE ABOVE

      NCOM=N
      DO 11 J=1,N
        PCOM(J)=P(J)
        XICOM(J)=XI(J)
11    CONTINUE
      AX=0.
      XX=1.
      BX=2.
      CALL MNBRAK(AX,XX,BX,FA,FX,FB,F1DIM)
      FRET=BRENT(AX,XX,BX,F1DIM,TOL,XMIN)
      DO 12 J=1,N
        XI(J)=XMIN*XI(J)
        P(J)=P(J)+XI(J)
12    CONTINUE        

C     ADDED CODE BELOW TO CONTROL RANGE OF VARAIBLES
      IF ( P(2) .LE. 0.01) THEN
       P(2) = 0.01
      END IF
      IF ( P(2) .GE. 1.0) THEN
       P(2) = 1.0
      END IF       
C     ADDED CODE ABOVE

      RETURN
      END
                     

C     ADDED CODE FROM PRESS, ET AL, 1986, PAGE 301.
      FUNCTION F1DIM(X)
      PARAMETER (NMAX=50)
      COMMON /F1COM/ NCOM, PCOM(NMAX), XICOM(NMAX)
      DIMENSION XT(NMAX)
      DO J = 1, NCOM
       XT(J) = PCOM(J) + X * XICOM(J)
      END DO
      F1DIM = FUNC(XT)
      RETURN
      END              
      