C     RDPG MODEL
C     PAPA.FOR
C     FIND INITIAL PARAMETER VALUES


      SUBROUTINE PARA

C     DECLARE VARAIBLES

C     P: RAIN-DAY PARAMETERS
      REAL P(1:4)
C     FTOL: TOLERANCE OF THE CALCULALTION      
      REAL FTOL
C     FRET: GUESS OF THE MINIMUM VALUE OF THE FUNCTION      
      REAL FRET      
C     LIM_LOW, LIM_HIGH: RANGE OF RAINFALL DATA IN A DAY      
      REAL LIM_LOW, LIM_HIGH
C     RAIN_REALDATA: REAL OR ACTUAL RAINFALL DATA
      REAL RAIN_REALDATA(1:100)
C     INDEX: A INDEX OF RAIN-DAY
      INTEGER INDEX

C     COMMONLY USED VARIABLES IN FILES
      COMMON /COM_1/   RAIN_REALDATA            
      COMMON /COM_11/  INDEX
      
C     INITIALIZE VARIABLES
C     NUMBER OF PARAMETERS IN THE TARGET PARAMETER ARRAY
      N = 4                                              
      FTOL = 1.0E-3            
      FRET = 1.0E-3

C     P(1): TIME TO PEAK, P(2): RAIN DISPERSION COEFFICIENT
C     P(3): RAIN DURATION, P(4): PEAK RATE
      P(1) = 0.00
      P(2) = 0.01
      P(3) = 0.00
      P(4) = 0.00

C     FIND P(4) AND P(1)       
      DO 820, K = 1, 96
       IF (P(4) .GE. RAIN_REALDATA(K)) THEN 
        GOTO 820
       ELSE
        P(4) = RAIN_REALDATA(K)
        P(1) = K * 15.0
        GOTO 820
       END IF  
820   CONTINUE
      
      DO J = 1, 96
       IF (RAIN_REALDATA(J) .NE. 0.00) THEN
        LIM_LOW = J
       GOTO 2100
       END IF
      END DO
      
2100  DO M = 96, 1, -1
       IF (RAIN_REALDATA(M) .NE. 0.00) THEN
        LIM_HIGH = M
       GOTO 2500
       END IF
      END DO

C     FIND P(3)
2500  IF ( (LIM_HIGH - LIM_LOW) .LE. 1.0 ) THEN 
       P(3) = 15.0
      ELSE 
       P(3) = (LIM_HIGH - LIM_LOW) * 15.0 / 2.0
      END IF 

C     FIND FINAL P(1)      
      IF ( (P(1) - P(3)/2) .LE. 0.00) THEN
       P(1) = 15.0
      ELSE 
       P(1) = P(1) - (P(3) / 2)
      END IF

C     CALL QUASI-NEWTON ALGORITHM
      CALL DFPMIN(P,N,FTOL,ITER,FRET)

C     OUTPUT
      WRITE (12, 6040) INDEX, P(1), P(2), P(3), P(4)/100.0
6040  FORMAT(I9, F9.2, F9.2, F9.2, F9.4, F9.2)      

      END
      